<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="m-4">

  <div
    id="sealListTitle"
    class="h4"
    [innerText]="messages.SEAL_TITLE">
  </div>

  <div class="pt-3 d-flex align-items-start">

    <button
      ls-button
      (click)="openEditSealPopup(null)"
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.SEAL_IMPORT"
      [disabled]="!tenantId">
    </button>

    <span class="flex-grow-1"></span>
    <span
      class="p-1 px-2"
      [innerText]="commonMessages.PAGINATION_SIZE_LABEL">
    </span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="refreshSealCertificateList()">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="sealListTitle"
    class="mt-3 bg-white table table-fixed table-striped table-borderless border shadow-sm">

    <thead class="border">
      <tr>
        <th
          *ngIf="userPreferences.showAdminIds"
          class="th-sm col-id-fixed-size"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Id)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true"></fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th
          class="th-sm"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Name)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Name ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true"></fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          class="th-sm col-date-fixed-size"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.ExpirationDate)">
          <fa-icon
            class="{{ sortBy === sortByEnum.ExpirationDate ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true"></fa-icon>
          {{ messages.SEAL_EXP_DATE }}
        </th>
        <th
          class="th-sm col-buttons-fixed-size"
          scope="col"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let sealCertificate of sealCertificateList">
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="sealCertificate.id | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="sealCertificate.name | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row {{ isExpired(sealCertificate) ? 'text-danger' : '' }}"
            [innerText]="sealCertificate.expirationDate | date: 'shortDate'">
          </span>
        </td>
        <td class="d-flex">
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [title]="commonMessages.EDIT"
            (click)="openEditSealPopup(sealCertificate.id)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>

          <button
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            (mouseenter)="refreshUsage(sealCertificate)"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(sealCertificate)">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="sealCertificateList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_SEAL_CERTIFICATE_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshSealCertificateList()">
  </ngb-pagination>

</div>
